import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";

---------------------------------- Basic Variables

blau = Turbine.UI.Color( 0, 0, 1 ); -- 0
rot = Turbine.UI.Color( 1, 0, 0 );  -- 1
gelb = Turbine.UI.Color( 0, 1, 0 ); -- 2

wa = {};
sWA= {};

wa.color = 0;
wa.x    = 200;
wa.y    = 200;
wa.dis	= 50;
wa.row 	= 5;
wa.opa 	= 1;
wa.opaf = 0.8;
wa.show = 0;
wa.itemCache = -1;
wa.items= {};
wa.count= 0;

gapString = "Default Gap String12345*";

me = Turbine.Gameplay.LocalPlayer.GetInstance(); --Player

eq = me:GetEquipment(); --Equiped Items
bp = me:GetBackpack();  --Bagpack Items

---------------------------------- Load SaveData

if Turbine.PluginData.Load(Turbine.DataScope.Character, "WeaponAssist") ~= nil then

	sWA = Turbine.PluginData.Load(Turbine.DataScope.Character, "WeaponAssist");
	
	wa.count = tonumber(sWA.count);
	wa.x     = tonumber(sWA.x);
	wa.y     = tonumber(sWA.y);
	wa.dis	 = tonumber(sWA.dis);
	wa.row	 = tonumber(sWA.row);
	wa.opa	 = tonumber(sWA.opa);
	wa.opaf	 = tonumber(sWA.opaf);
	wa.show	 = tonumber(sWA.show);
	wa.color = tonumber(sWA.color);
	
	if wa.count > 0 then
	
		local check = 0;
		local cache = "";
		local posCache = 0;
		local textCache = 0;
		local test = true;
	
		for i = 1, wa.count, 1 do
		
			check = 0;
			cache = "";
			
			for k = 1, bp:GetSize()-1, 1 do
			
				if bp:GetItem(k) ~= nil then
			
					if sWA.itemList["a"..i].item == bp:GetItem(k):GetName() then
						
						if check == 0 then
						
							cache = bp:GetItem(k);
							posCache= tonumber(sWA.itemList["a"..i].pos);
							textCache= sWA.itemList["a"..i].text;

					
						end
						
						check = check+1;
					
					end
				
				end
			
			end
			
			
			for j = 1, eq:GetSize(), 1 do
			
				if eq:GetItem(j) ~= nil then
				
					if sWA.itemList["a"..i].item == eq:GetItem(j):GetName() then
						
						if check == 0 then
						
							cache   = eq:GetItem(j);
							posCache= tonumber(sWA.itemList["a"..i].pos);
							textCache= sWA.itemList["a"..i].text;

						end
						
						check = check+1;
					
					end
					
				end	
					
			end
			
			if sWA.itemList["a"..i].text == gapString then
			
				cache   = "";
				posCache= tonumber(sWA.itemList["a"..i].pos);
				textCache= gapString;
			
				check = check+1;
			
			end
					
			if check == 1 then
	
				wa.items[i] = {};
				wa.items[i].item = cache;
				wa.items[i].pos  = posCache; 
				wa.items[i].text  = textCache; 
			
				else if check > 1 then
			
						Turbine.Shell.WriteLine("You have more then 1 item with the name "..cache:GetName()..".");
						wa.items[i] = {};
						wa.items[i].item = cache;
						wa.items[i].pos  = posCache; 
						wa.items[i].text = textCache; 
			
					else if check == 0 then
			
						Turbine.Shell.WriteLine("The item with the name "..sWA.itemList["a"..i].item.." was not found. And has been removed.");
						test = false;
			
					end
			
				end
			
			end
			
		end
		
		if test == false then

			for i=1 , wa.count , 1 do
			
				if wa.items[i] == nil then
				
					wa.count = wa.count-1;
				
					if i < wa.count then
					
						for j=i , wa.count , 1 do
						
							wa.items[i] = wa.items[i+1];
						
						end
					
					end
	
				
				end
			
			end
		
		end
		
	end	

end	



function Save()
	
		sWA 		= {};
		sWA.x		= tostring(wa.x);
		sWA.y		= tostring(wa.y);
		sWA.dis		= tostring(wa.dis);
		sWA.row		= tostring(wa.row);
		sWA.opa		= tostring(wa.opa);
		sWA.opaf	= tostring(wa.opaf);
		sWA.count   = tostring(wa.count);
		sWA.show	= tostring(wa.show);
		sWA.color	= tostring(wa.color);
		
		
		sWA.itemList = {};
		
		for j = 1, wa.count, 1 do
		
			sWA.itemList["a"..j] = {}
			
			if wa.items[j].text == gapString then
			
				sWA.itemList["a"..j].item = "";
			
			else
			
				sWA.itemList["a"..j].item = wa.items[j].item:GetName();
			
			end
			
			sWA.itemList["a"..j].pos = 	tostring(wa.items[j].pos);
			
			if wa.items[j].text == gapString then
			
				sWA.itemList["a"..j].text = gapString;
			
			else 
			
				sWA.itemList["a"..j].text = wa.items[j].text;
			
			end
			
			
		
		end
	
	
	
	Turbine.PluginData.Save(Turbine.DataScope.Character, "weaponAssist", sWA);

end

Save();

----------------------------------

core = Turbine.UI.Window();

core:SetPosition(wa.x,wa.y);
core:SetVisible(true);
core:SetMouseVisible(false);

move = Turbine.UI.Window();

--move:SetParent(core);
move:SetBackColor(rot);
move:SetSize(50,50);
move:SetPosition(wa.x-50,wa.y-50);
move:SetVisible(false);


function move:MouseDown( args )
	if ( args.Button == Turbine.UI.MouseButton.Left ) then
	
		wa.dragStartX = args.X;
		wa.dragStartY = args.Y;
		wa.dragging = true;
		
	end
end
	
function move:MouseMove( args )
	local left, top = move:GetPosition();
	
	if ( wa.dragging ) then
	
		wa.x = ( left + ( args.X - wa.dragStartX )+50);
		wa.y = (top + ( args.Y - wa.dragStartY )+50 );
		
		core:SetPosition( wa.x ,wa.y );
		move:SetPosition( wa.x-50 , wa.y-50  );
		
	end
end

function move:MouseUp( args )
	if ( args.Button == Turbine.UI.MouseButton.Left ) then
	
		Save();
		wa.dragging = false;
		
	end
end


----------------------------------

function createUI(itemNumber)

	wa.items[itemNumber].window = Turbine.UI.Window();
	wa.items[itemNumber].window:SetParent(core);
	wa.items[itemNumber].window:SetSize(42,42);
	--wa.items[itemNumber].window:SetPosition(xdis,ydis);
	wa.items[itemNumber].window:SetVisible(false);
	wa.items[itemNumber].window:SetOpacity(wa.opaf);
	wa.items[itemNumber].window:SetZOrder(1);
	
	wa.items[itemNumber].back = Turbine.UI.Window();
	wa.items[itemNumber].back:SetParent(core);
	--wa.items[itemNumber].back:SetPosition(xdis,ydis);
	wa.items[itemNumber].back:SetSize(42,42);
	wa.items[itemNumber].back:SetZOrder(2);
	wa.items[itemNumber].back:SetVisible(false);
	wa.items[itemNumber].back:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	
	wa.items[itemNumber].ic = Turbine.UI.Lotro.ItemControl();
	wa.items[itemNumber].ic:SetParent(wa.items[itemNumber].back);
	wa.items[itemNumber].ic:SetPosition(2,2);
	wa.items[itemNumber].ic:SetItem(wa.items[itemNumber].item);
	wa.items[itemNumber].ic:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	
	wa.items[itemNumber].label = Turbine.UI.Label();
	wa.items[itemNumber].label:SetParent(wa.items[itemNumber].ic);
	wa.items[itemNumber].label:SetPosition(0,0);
	wa.items[itemNumber].label:SetSize(36,36);
	wa.items[itemNumber].label:SetVisible(false);
	wa.items[itemNumber].label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	wa.items[itemNumber].label:SetFontStyle(Turbine.UI.FontStyle.Outline);
	wa.items[itemNumber].label:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36);
	wa.items[itemNumber].label:SetMouseVisible(false);
	wa.items[itemNumber].label:SetZOrder(3);
	wa.items[itemNumber].label:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	
	if wa.items[itemNumber].text ~= "" then
	
		wa.items[itemNumber].label:SetText(wa.items[itemNumber].text);
		wa.items[itemNumber].label:SetVisible(true);
	
	end
	
	if wa.color == 0 then
	
			wa.items[itemNumber].window:SetBackColor(blau);
		
		else if wa.color == 1 then

			wa.items[itemNumber].window:SetBackColor(rot);

			else if wa.color == 2 then
			
				wa.items[itemNumber].window:SetBackColor(gelb);
			
			end
			
		end
		
	end

	if wa.show == 0 then

		wa.items[itemNumber].back:SetVisible(true);
		
	end					
	
	
	for i = 1, eq:GetSize() ,1 do
	
		if eq:GetItem(i) ~= nil then
	
			local ti = eq:GetItem(i):GetName();
	
			if wa.items[itemNumber].item:GetName() == ti then

				if wa.show == 1 then
				
					wa.items[itemNumber].window:SetVisible(true);
					wa.items[itemNumber].back:SetVisible(true);
					
				else if wa.show == 0 then

						wa.items[itemNumber].window:SetVisible(true);
				
					end
					
				end	

							
				return;
				
			end	
			
		end	
		
	end	
		
	 

end



function posItems()

	
	local y = 0;
	local x = 0;
	local yt= 0;
	
	local xdis = 0;
	local ydis = 0;
	
	if wa.count > wa.row then
		
		core:SetSize(wa.row*wa.dis,(math.floor(wa.count / wa.row)+1)*wa.dis);
		
	else
	
		core:SetSize(wa.count*wa.dis,(math.floor(wa.count / wa.row))+1*wa.dis);
	
	end
	
	for i = 1, wa.count, 1 do
	
		if wa.items[i].text ~= gapString then

			yt = math.floor(((i-1) / wa.row));
			x  = (i-1) % (wa.row);
		
			xdis = x*wa.dis;
			ydis = yt*wa.dis;
			
			wa.items[i].window:SetPosition(xdis,ydis);
			wa.items[i].back:SetPosition(xdis,ydis);
			
		end

	end

end


function loadAllUI() -- load ui from save

	if wa.count > 0 then
		
		for i = 1, wa.count, 1 do	

			if wa.items[i].text ~= gapString then
			
					createUI(i);

				end	

			createSettingQs(i);

		end
		
		removeItemSettings()
		
		posItems();
			
	end

end

function  loadSingleUI() --add new ui from settings

	if wa.count > 0 then
	
		core:SetSize(wa.row,math.floor(wa.count / wa.row)*wa.dis);
		
		if wa.items[wa.count].text ~= gapString then
			
			createUI(wa.count);

		end	
		
		createSettingQs(wa.count)	
			
		removeItemSettings();
	
		posItems();
	
	end

end


---------------------------------- 

function itemEquipedCheck()

	eq.ItemUnequipped = function(sender, args)
	
		local it = me:GetEquipment():GetItem(args.Index):GetName();
	
		for i = 1, wa.count, 1 do
		
			if wa.items[i].text ~= gapString then
		
				if wa.items[i].item:GetName() == it then
				
					wa.items[i].window:SetVisible(false);
					
					if wa.show == 1 then
					
					
					
						wa.items[i].back:SetVisible(false);
					
					end
				
				end
			
			end
		
		end
	
	end
	
	eq.ItemEquipped = function(sender, args)
	
		local it = me:GetEquipment():GetItem(args.Index):GetName();
		
		for i = 1, wa.count, 1 do
		
			if wa.items[i].text ~= gapString then
		
				if wa.items[i].item:GetName() == it then
				
					wa.items[i].window:SetVisible(true);
					wa.items[i].back:SetVisible(true);

				
				end
			
			end
		
		end
	
	end

end

---------------------------------- 

import "Souru.WeaponAssist.Settings";

loadAllUI();
itemEquipedCheck();

