import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";


----------------------------------

optionsPanel = Turbine.UI.Control();
optionsPanel:SetSize( 600, 600 );

---------------------------------- Setting UI

qs 				= Turbine.UI.Lotro.Quickslot();	-- Quickslot 
qsAddButton 	= Turbine.UI.Lotro.Button(); 	-- Button to add item from Quickslot
gapAddButton 	= Turbine.UI.Lotro.Button(); 	-- Button to add item from Quickslot
mButton		 	= Turbine.UI.Lotro.Button(); 	-- Button to save markings
mcB				= Turbine.UI.Lotro.CheckBox();	-- Movecheckbox
fcRed			= Turbine.UI.Label();			-- Choice window for framecolor Red
fcBlue			= Turbine.UI.Label();			-- Choice window for framecolor Blue	
fcYellow		= Turbine.UI.Label();			-- Choice window for framecolor Yellow
dSue			= Turbine.UI.Lotro.CheckBox();	-- Dont show unequiped items checkbox
rN				=  Turbine.UI.Lotro.TextBox();	-- Textbox to type number of items in a row
dis				=  Turbine.UI.Lotro.TextBox();	-- Textbox to type distance between items
opa				=  Turbine.UI.Lotro.TextBox();	-- Textbox to type the opacity
opaf			=  Turbine.UI.Lotro.TextBox();	-- Textbox to type the opacity of the frame
rButton		 	= Turbine.UI.Lotro.Button(); 	-- Button to save row number
dButton		 	= Turbine.UI.Lotro.Button(); 	-- Button to save distance
oButton		 	= Turbine.UI.Lotro.Button(); 	-- Button to save opacity
fButton		 	= Turbine.UI.Lotro.Button(); 	-- Button to save opacity of the frame



settingLabelAdd = Turbine.UI.Label(); 			-- Label for adding new item
settingLabelAddG= Turbine.UI.Label(); 			-- Label for adding new item
settingLabelRsm = Turbine.UI.Label(); 			-- Label for removing/swaping/marking
settingLabelMcb = Turbine.UI.Label();			-- Label for the move checkbox
settingLabelfC  = Turbine.UI.Label();			-- Label for frame color
settingLabeldS  = Turbine.UI.Label();			-- Label for dont show unequiped items
settingLabelCos = Turbine.UI.Label();			-- Label for cosmetics
settingLabelRn  = Turbine.UI.Label();			-- Label for row number
settingLabelDis = Turbine.UI.Label();			-- Label for distance beteewn items 
settingLabelRem = Turbine.UI.Label();			-- Label as tooltipp for remove
settingLabelSwa = Turbine.UI.Label();			-- Label as tooltipp for swap
settingLabelMar = Turbine.UI.Label();			-- Label as tooltipp for mark 
settingLabelOpa = Turbine.UI.Label();			-- Label as tooltipp for opacity
settingLabelOpaf= Turbine.UI.Label();			-- Label as tooltipp for opacity of the frame
settingLabelCol = Turbine.UI.Label();			-- Label as tooltipp for opacity of the frame

-- Add new items

settingLabelAdd:SetParent(optionsPanel);
settingLabelAdd:SetPosition(20 , 25);
settingLabelAdd:SetSize(100,20);
settingLabelAdd:SetFont(Turbine.UI.Lotro.Font.Verdana14);
settingLabelAdd:SetVisible(true);
settingLabelAdd:SetText("Add new item");

qs:SetParent(optionsPanel);
qs:SetPosition(50 , 50);
qs:SetVisible(true);
qs:SetBackColor(Turbine.UI.Color( 0, 0, 1 ));

qsAddButton:SetParent(optionsPanel);
qsAddButton:SetPosition(100 , 60);
qsAddButton:SetVisible(true);
qsAddButton:SetText("Add");

gapAddButton:SetParent(optionsPanel);
gapAddButton:SetPosition(200 , 60);
gapAddButton:SetWidth(70);
gapAddButton:SetVisible(true);
gapAddButton:SetText("Add Gap");

settingLabelAddG:SetParent(optionsPanel);
settingLabelAddG:SetPosition(280 , 60);
settingLabelAddG:SetSize(140,30);
settingLabelAddG:SetVisible(true);
settingLabelAddG:SetText("- Add a gap between your items");


-- Remove swap or mark 


settingLabelRsm:SetParent(optionsPanel);
settingLabelRsm:SetPosition(20 , 120);
settingLabelRsm:SetWidth(150);
settingLabelRsm:SetFont(Turbine.UI.Lotro.Font.Verdana14);
settingLabelRsm:SetVisible(true);
settingLabelRsm:SetText("Remove Swap or Mark");

-- Move window

settingLabelMcb:SetParent(optionsPanel);
settingLabelMcb:SetPosition(20 , 275);
settingLabelMcb:SetWidth(100);
settingLabelMcb:SetFont(Turbine.UI.Lotro.Font.Verdana14);
settingLabelMcb:SetVisible(true);
settingLabelMcb:SetText("Move Window");

mcB:SetParent(optionsPanel);
mcB:SetPosition(50,280);
mcB:SetWidth(300);
mcB:SetText(" If checked you can move the window");

-- Choose Framecolor

settingLabelfC:SetParent(optionsPanel);
settingLabelfC:SetPosition(20 , 340);
settingLabelfC:SetWidth(150);
settingLabelfC:SetFont(Turbine.UI.Lotro.Font.Verdana14);
settingLabelfC:SetVisible(true);
settingLabelfC:SetText("Choose framecolor");

settingLabelCol:SetParent(optionsPanel);
settingLabelCol:SetPosition((wa.color+1)*50,360);
settingLabelCol:SetSize(40,25);
settingLabelCol:SetFont(Turbine.UI.Lotro.Font.Verdana18);
settingLabelCol:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
settingLabelCol:SetFontStyle(Turbine.UI.FontStyle.Outline);
settingLabelCol:SetVisible(true);
settingLabelCol:SetText("X");
settingLabelCol:SetZOrder(3);

fcRed:SetParent(optionsPanel);
fcRed:SetPosition(100,360);
fcRed:SetSize(40,25);
fcRed:SetBackColor(rot);
fcRed:SetVisible(true);

fcBlue:SetParent(optionsPanel);
fcBlue:SetPosition(50,360);
fcBlue:SetSize(40,25);
fcBlue:SetBackColor(blau);
fcBlue:SetVisible(true);

fcYellow:SetParent(optionsPanel);
fcYellow:SetPosition(150,360);
fcYellow:SetSize(40,25);
fcYellow:SetBackColor(gelb);
fcYellow:SetVisible(true);

-- Show / Dont show unequiped Items

settingLabeldS:SetParent(optionsPanel);
settingLabeldS:SetPosition(20 , 415);
settingLabeldS:SetWidth(300);
settingLabeldS:SetFont(Turbine.UI.Lotro.Font.Verdana14);
settingLabeldS:SetVisible(true);
settingLabeldS:SetText("Show / Dont show unequiped items");

dSue:SetParent(optionsPanel);
dSue:SetPosition(50,420);
dSue:SetWidth(350);
dSue:SetText(" If checked you can't see unequiped items");

if wa.show == 1 then

	dSue:SetChecked(true);

end

-- Cosmetics

settingLabelCos:SetParent(optionsPanel);
settingLabelCos:SetPosition(20 , 480);
settingLabelCos:SetWidth(100);
settingLabelCos:SetFont(Turbine.UI.Lotro.Font.Verdana14);
settingLabelCos:SetVisible(true);
settingLabelCos:SetText("Cosmetics");

rN:SetParent(optionsPanel);
rN:SetPosition(50,500);
rN:SetSize(42,25);
rN:SetVisible(true);
rN:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
rN:SetText(wa.row);

rButton:SetParent(optionsPanel);
rButton:SetPosition(100 , 503);
rButton:SetWidth(40);
rButton:SetVisible(true);
rButton:SetText("Save");

settingLabelRn:SetParent(optionsPanel);
settingLabelRn:SetPosition(150 , 505);
settingLabelRn:SetWidth(300);
settingLabelRn:SetVisible(true);
settingLabelRn:SetText("Number of items in a row (atleast 1)");

dis:SetParent(optionsPanel);
dis:SetPosition(50,530);
dis:SetSize(42,25);
dis:SetVisible(true);
dis:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
dis:SetText(wa.dis);

dButton:SetParent(optionsPanel);
dButton:SetPosition(100 , 533);
dButton:SetWidth(40);
dButton:SetVisible(true);
dButton:SetText("Save");

settingLabelDis:SetParent(optionsPanel);
settingLabelDis:SetPosition(150,536);
settingLabelDis:SetWidth(300);
settingLabelDis:SetVisible(true);
settingLabelDis:SetText("Distance between items (atleast 32 or 0)");

opa:SetParent(optionsPanel);
opa:SetPosition(50,560);
opa:SetSize(42,25);
opa:SetVisible(true);
opa:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
opa:SetText(wa.opa);

oButton:SetParent(optionsPanel);
oButton:SetPosition(100 , 563);
oButton:SetWidth(40);
oButton:SetVisible(true);
oButton:SetText("Save");

settingLabelOpa:SetParent(optionsPanel);
settingLabelOpa:SetPosition(150,567);
settingLabelOpa:SetWidth(300);
settingLabelOpa:SetVisible(true);
settingLabelOpa:SetText("Opacity (0-1)");

opaf:SetParent(optionsPanel);
opaf:SetPosition(250,560);
opaf:SetSize(42,25);
opaf:SetVisible(true);
opaf:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
opaf:SetText(wa.opaf);

fButton:SetParent(optionsPanel);
fButton:SetPosition(300 , 563);
fButton:SetWidth(40);
fButton:SetVisible(true);
fButton:SetText("Save");

settingLabelOpaf:SetParent(optionsPanel);
settingLabelOpaf:SetPosition(340,567);
settingLabelOpaf:SetWidth(300);
settingLabelOpaf:SetVisible(true);
settingLabelOpaf:SetText(" Frame opacity (0-1)");

settingLabelRem:SetParent(optionsPanel);

settingLabelRem:SetWidth(300);
settingLabelRem:SetVisible(true);
settingLabelRem:SetText("- Push button to remove item below");

settingLabelSwa:SetParent(optionsPanel);

settingLabelSwa:SetWidth(250);
settingLabelSwa:SetVisible(true);
settingLabelSwa:SetText("- Pull item onto the item you want to swap it with");

mButton:SetParent(optionsPanel);

mButton:SetWidth(40);
mButton:SetVisible(true);
mButton:SetText("Save");

settingLabelMar:SetParent(optionsPanel);

settingLabelMar:SetWidth(250);
settingLabelMar:SetVisible(true);
settingLabelMar:SetText("- Type in a single letter to mark items and push button");

if wa.count > 0 then

	settingLabelRem:SetPosition((wa.count*50)+47 , 144);
	settingLabelSwa:SetPosition((wa.count+1)*50 , 175);
	mButton:SetPosition((wa.count*50)+47 , 222);
	settingLabelMar:SetPosition(((wa.count+1)*50)+47 , 220);
	
else

	settingLabelRem:SetPosition(50 , 144);
	settingLabelSwa:SetPosition(50 , 175);
	mButton:SetPosition(50 , 222);
	settingLabelMar:SetPosition(100 , 220);

end


---------------------------------- setting functions

mButton.MouseClick = function() -- function to add item from quickslot

	local text = "";

	for i=1 , wa.count , 1 do
	
		text = wa.items[i].tB:GetText();
		
		if string.len(text) < 2 then

			wa.items[i].text = text;
			wa.items[i].label:SetText(text);
			wa.items[i].label:SetVisible(true);
			
		else

			Turbine.Shell.WriteLine("Only use single letters or numbers to mark items.");
		
		end

	end
	
	Save();
	
end

function fcBlue:MouseDown( args )
	if ( args.Button == Turbine.UI.MouseButton.Left ) then
	
		if wa.count > 0 then
		
			for i=1 , wa.count , 1 do
						
				wa.items[i].window:SetBackColor(blau);

			end
		
		end
		
		settingLabelCol:SetPosition(50,360);
		
		wa.color = 0;
		
		Save();
		
	end
end

function fcRed:MouseDown( args )

	if ( args.Button == Turbine.UI.MouseButton.Left ) then
	
		if wa.count > 0 then
		
			for i=1 , wa.count , 1 do
						
				wa.items[i].window:SetBackColor(rot);

			end
		
		end
		
		settingLabelCol:SetPosition(100,360);
		
		wa.color = 1;
		
		Save();
		
	end
end

function fcYellow:MouseDown( args )
	if ( args.Button == Turbine.UI.MouseButton.Left ) then
	
		if wa.count > 0 then
		
			for i=1 , wa.count , 1 do
						
				wa.items[i].window:SetBackColor(gelb);

			end
		
		end
		
		settingLabelCol:SetPosition(150,360);
		
		wa.color = 2;
		
		Save();
		
	end
end

mcB.CheckedChanged = function(sender,args)

	if mcB:IsChecked() == true then
	
		move:SetVisible(true);
	
	else
	
		move:SetVisible(false);
	
	end

	Save();

end

dSue.CheckedChanged = function(sender,args)

	if dSue:IsChecked() == true then
	
		wa.show = 1;
		
		for i = 1, wa.count , 1 do

			if wa.items[i].text ~= gapString then
		
				if wa.items[i].window:IsVisible() then
				
				else
			
					wa.items[i].back:SetVisible(false);
				
				end
			
			end
		
		end
	
	else
	
		wa.show = 0;
		
		for i = 1, wa.count , 1 do
		
			if wa.items[i].text ~= gapString then
		
				wa.items[i].back:SetVisible(true);
		
			end
		
		end
	
	end

	Save();

end

function removeItemSettings()

	if wa.count > 0 then
	
		for item=1, wa.count, 1 do
		
			wa.items[item].sQs:SetPosition(item*50 , 170);
			wa.items[item].rB:SetPosition(((item)*50)-3 , 140);
			wa.items[item].tB:SetPosition(((item)*50)-3 , 220);
			
			wa.items[item].rB.MouseClick = function() -- function to remove items

				removeItem(item);

			end
		
		end
		
			settingLabelRem:SetPosition(((wa.count)*50)+47 , 144);
			settingLabelSwa:SetPosition((wa.count+1)*50 , 175);
			mButton:SetPosition(((wa.count)*50)+47 , 222);
			settingLabelMar:SetPosition((((wa.count)+1)*50)+47 , 220);
		
	
	end

end

function removeItem(item)

	local po = wa.items[item].pos;

	if wa.items[item].text ~= gapString then
	
		if item == wa.count then

			wa.items[item].window:SetVisible(false);
			wa.items[item].back:SetVisible(false);
			
			wa.items[item].sQs:SetVisible(false);
			wa.items[item].rB:SetVisible(false);
			wa.items[item].tB:SetVisible(false);
		
		else 
		
			wa.items[item].window:SetVisible(false);
			wa.items[item].back:SetVisible(false);
			
			wa.items[item].sQs:SetVisible(false);
			wa.items[item].rB:SetVisible(false);
			wa.items[item].tB:SetVisible(false);
			
			for i = item, wa.count-1, 1 do
			
				wa.items[i] = wa.items[i+1];
			
			end
			
			if po ~= wa.count then
			
				for j=po+1, wa.count, 1 do
				
					for k= wa.count, 1 , -1 do
					
						if wa.items[k].pos == j then
						
							wa.items[k].pos = j-1;
							
							break;
						
						end
					
					end
				
				end
			
			end
			
		end	
	
	else 
	
		if item == wa.count then
	
			wa.items[item].sQs:SetVisible(false);
			wa.items[item].rB:SetVisible(false);
		
		else 

			wa.items[item].sQs:SetVisible(false);
			wa.items[item].rB:SetVisible(false);
			
			for i = item, wa.count-1, 1 do
			
				wa.items[i] = wa.items[i+1];
			
			end
			
			if po ~= wa.count then
			
				for j=po+1, wa.count, 1 do
				
					for k= wa.count, 1 , -1 do
					
						if wa.items[k].pos == j then
						
							wa.items[k].pos = j-1;
							
							break;
						
						end
					
					end
				
				end
			
			end
			
		end	
	
	end
	
	wa.count = wa.count-1;

	removeItemSettings();
			
	posItems();
			
	Save();
			

end

function draggin(item)

	if wa.itemCache ~= item then
			
		local s = wa.items[wa.itemCache];
		local c = wa.itemCache;
		
		wa.items[c] = wa.items[item];
		wa.items[item] 		   = s;
		
		wa.items[c].pos = c;
		wa.items[item].pos			   = item;
		
		wa.items[item].sQs:SetPosition(item*50 , 170);
		wa.items[item].rB:SetPosition(((item)*50)-3 , 140);
		wa.items[item].tB:SetPosition(((item)*50)-3 , 220);
		
		wa.items[c].sQs:SetPosition(c*50 , 170);
		wa.items[c].rB:SetPosition(((c)*50)-3 , 140);
		wa.items[c].tB:SetPosition(((c)*50)-3 , 220);
		
		posItems();
		
		wa.items[item].sQs.DragLeave = function(sender, args)
	
		if wa.itemCache == -1 then
		
			wa.itemCache = wa.items[item].pos;
		
		end
	
		end	
		
		wa.items[item].sQs.DragDrop = function(sender, args)
		
			if wa.itemCache ~= -1 then
			
				draggin(item);
			
			end
		
		end
		
		wa.items[c].sQs.DragLeave = function(sender, args)
	
		if wa.itemCache == -1 then
		
			wa.itemCache = wa.items[c].pos;
		
		end
	
		end	
		
		wa.items[c].sQs.DragDrop = function(sender, args)
		
			if wa.itemCache ~= -1 then
			
				draggin(c);
			
			end
		
		end
		
	end

	wa.itemCache = -1;
	
	Save();

end

function createSettingQs(item)
	
	wa.items[item].rB  =  Turbine.UI.Lotro.Button();
	wa.items[item].tB  =  Turbine.UI.Lotro.TextBox();
	
	
	if wa.items[item].text == gapString then
	
		wa.items[item].sQs =  Turbine.UI.Window();
		wa.items[item].sQs:SetParent(optionsPanel);
		wa.items[item].sQs:SetSize(35,35);
		wa.items[item].sQs:SetVisible(true);
		wa.items[item].sQs:SetBackColor(Turbine.UI.Color( 0, 1, 0 ));	
		wa.items[item].sQs:SetAllowDrop(true);
		
		wa.items[item].tB:SetVisible(false);
	
	else
	
		wa.items[item].sQs =  Turbine.UI.Lotro.ItemControl();
		wa.items[item].sQs:SetParent(optionsPanel);
		wa.items[item].sQs:SetVisible(true);
		wa.items[item].sQs:SetBackColor(Turbine.UI.Color( 0, 1, 0 ));
		wa.items[item].sQs:SetItem(wa.items[item].item);
		wa.items[item].sQs:SetAllowDrop(true);
		
		
		wa.items[item].tB:SetVisible(true);
		
	end	
	
	wa.items[item].rB:SetParent(optionsPanel);
	wa.items[item].rB:SetVisible(true);
	wa.items[item].rB:SetText("X");
	wa.items[item].rB:SetWidth(42);
	
	wa.items[item].tB:SetParent(optionsPanel);
	wa.items[item].tB:SetSize(42,25);
	
	wa.items[item].tB:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	wa.items[item].tB:SetText("");
	
	if wa.items[item].text ~= "" then
	
		wa.items[item].tB:SetText(wa.items[item].text);
	
	end
	
	wa.items[item].sQs.DragLeave = function(sender, args)
	
		if wa.itemCache == -1 then
		
			wa.itemCache = wa.items[item].pos;
		
		end
	
	end	
	
	wa.items[item].sQs.DragDrop = function(sender, args)
	
		if wa.itemCache ~= -1 then
		
			draggin(item);
		
		end
	
	end
	
	
end
	

qsAddButton.MouseClick = function() -- function to add item from quickslot

	if qs:GetShortcut():GetItem() ~= nil then

		wa.count = wa.count+1;
		wa.items[wa.count] = {};
		wa.items[wa.count].item = qs:GetShortcut():GetItem();
		wa.items[wa.count].pos = wa.count;
		wa.items[wa.count].text = "";
		
		Save();
		
		loadSingleUI();
		removeItemSettings()
		
	end	
	
end

gapAddButton.MouseClick = function() -- function to add a Gap

		wa.count = wa.count+1;
		wa.items[wa.count] = {};
		wa.items[wa.count].item = "";
		wa.items[wa.count].pos = wa.count;
		wa.items[wa.count].text = gapString;
		
		Save();
		
		loadSingleUI();
		removeItemSettings()

end

rButton.MouseClick = function() -- function to number of items in each row

	local text = tonumber(rN:GetText());

	if type(text) == "number" then
	
		if text == math.floor(text) then

			if text > 0 then
		
				wa.row = text;
				
				posItems();
				
				Save();
				
			else
			
				Turbine.Shell.WriteLine("Needs to be a integral number. (>0)");

			end
		
		else
		
			Turbine.Shell.WriteLine("Needs to be a integral number. (>0)");
			
		end	
	
	else
	
		Turbine.Shell.WriteLine("Needs to be a integral number. (>0)");
	
	end

end

dButton.MouseClick = function() -- function to change distance between items

	local text = tonumber(dis:GetText());

	if type(text) == "number" then
	
		if text > 31 or text == 0 then
		
			wa.dis = text;
			
			if wa.count > 0 then
				
				posItems();
			
				Save();				
		
			end
		
		else 
		
			Turbine.Shell.WriteLine("The distance between items needs to be atleast 32.");

		end
		
	else

		Turbine.Shell.WriteLine("You need to use a number.");
	
	end
	
end

fButton.MouseClick = function() -- function to change frame opacity

	local o = tonumber(opaf:GetText());
	
	if type(o) == "number" then
	
		if o > 0 and o <= 1 then
		
			wa.opaf = o;
			
			if wa.count > 0 then
			
				for i = 1 , wa.count , 1 do
				
					wa.items[i].window:SetOpacity(wa.opaf);
					
					Save();
				
				end
				
			end	
		
		else
		
			Turbine.Shell.WriteLine("Opacity value can only be between 0 and 1. 1 beeing no opacity atall and 0 beeing invisable.");
		
		end
	
	else
	
		Turbine.Shell.WriteLine("Opacity needs to be a number beteewn 0 and 1. 1 beeing no opacity atall and 0 beeing invisable.");
	
	end
	
end


oButton.MouseClick = function() -- function to change opacity

	local o = tonumber(opa:GetText());
	
	if type(o) == "number" then
	
		if o > 0 and o <= 1 then
		
			wa.opa = o;
			
			if wa.count > 0 then
			
				for i = 1 , wa.count , 1 do
				
					wa.items[i].back:SetOpacity(wa.opa);
					
					Save();
				
				end
				
			end	
		
		else
		
			Turbine.Shell.WriteLine("Opacity value can only be between 0 and 1. 1 beeing no opacity atall and 0 beeing invisable.");
		
		end
	
	else
	
		Turbine.Shell.WriteLine("Opacity needs to be a number beteewn 0 and 1. 1 beeing no opacity atall and 0 beeing invisable.");
	
	end
	
end

----------------------------------

optionsPanel.SizeChanged = function( sender, args )
  local optionsPanelWidth = optionsPanel:GetWidth();
  
  optionsPanel:SetHeight( optionsPanelWidth );
end

plugin.GetOptionsPanel = function( self )
  return optionsPanel;
end